Interface HttpServerRequest
- All Superinterfaces:
HttpRequestHead, ReadStream<Buffer>, StreamBase
- All Known Subinterfaces:
WebServerRequest
Instances are created for each request and passed to the user via a handler.
Each instance of this class is associated with a corresponding HttpServerResponse instance via
response().
It implements ReadStream so it can be used with
Pipe to pipe data with flow control.
- Author:
- Tim Fox
-
Field Summary
FieldsModifier and TypeFieldDescriptionstatic final Handler<HttpServerRequest> The default invalid request handler, it uses thedecoderResult()cause and the request information to determine the status code of the response to be sent. -
Method Summary
Modifier and TypeMethodDescriptionauthority(boolean real) body()Convenience method for receiving the entire request body in one piece.default HttpServerRequestbodyHandler(Handler<Buffer> bodyHandler) Convenience method for receiving the entire request body in one piece.longdefault booleandefault intcookies()Returns a modifiable set of parsed cookies from theCOOKIEheader.Returns a read only set of parsed cookies that match the given name, or an empty set.customFrameHandler(Handler<HttpFrame> handler) Set a custom frame handler.end()Returns a future signaling when the request has been fully received successfully or failed.endHandler(Handler<Void> endHandler) Set an end handler.exceptionHandler(Handler<Throwable> handler) Set an exception handler on the read stream.fetch(long amount) Fetch the specifiedamountof elements.Returns a map of all form attributes in the request.Get the cookie with the specified name.Get the cookie with the specified<name, domain, path>.getFormAttribute(String attributeName) Return the first form attribute value with the specified namedefault StringReturn the first param value with the specified namedefault StringReturn the first param value with the specified name ordefaultValuewhen the query param is not presentSet a data handler.booleanisEnded()Has the request ended?booleandefault booleanisSSL()default SocketAddressmethod()default MultiMapparams()params(boolean semicolonIsNormalChar) pause()Pause theReadStream, it sets the buffer infetchmode and clears the actual demand.default SocketAddressresponse()resume()Resume reading, and sets the buffer inflowingmode.default HttpServerRequestMarks this request as being routed to the given route.scheme()setExpectMultipart(boolean expect) Call this with true if you are expecting a multi-part body to be submitted in the request.setParamsCharset(String charset) Override the charset to use for decoding the query parameter map, when none is set,UTF8is used.default SSLSessiondefault longstreamId()default StreamPrioritystreamPriorityHandler(Handler<StreamPriority> handler) Set an handler for stream priority changesEstablish a TCP tunnel with the client.Upgrade the connection of the current request to a WebSocket.uploadHandler(Handler<HttpServerFileUpload> uploadHandler) Set an upload handler.version()Methods inherited from interface ReadStream
blockingStream, collect, pipe, pipeTo
-
Field Details
-
DEFAULT_INVALID_REQUEST_HANDLER
The default invalid request handler, it uses thedecoderResult()cause and the request information to determine the status code of the response to be sent.- When the cause is an instance of
io.netty.handler.codec.TooLongFrameExceptionand the error message starts with An HTTP line is larger than theREQUEST_URI_TOO_LONGstatus is sent - Otherwise when the cause is an instance of
io.netty.handler.codec.TooLongFrameExceptionand the error message starts with HTTP header is larger than theREQUEST_HEADER_FIELDS_TOO_LARGEstatus is sent - Otherwise then
BAD_REQUESTstatus is sent
- When the cause is an instance of
-
-
Method Details
-
exceptionHandler
Description copied from interface:ReadStreamSet an exception handler on the read stream.- Specified by:
exceptionHandlerin interfaceReadStream<Buffer>- Specified by:
exceptionHandlerin interfaceStreamBase- Parameters:
handler- the exception handler- Returns:
- a reference to this, so the API can be used fluently
-
handler
Description copied from interface:ReadStreamSet a data handler. As data is read, the handler will be called with the data.- Specified by:
handlerin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
pause
HttpServerRequest pause()Description copied from interface:ReadStreamPause theReadStream, it sets the buffer infetchmode and clears the actual demand.While it's paused, no data will be sent to the data
handler.- Specified by:
pausein interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
resume
HttpServerRequest resume()Description copied from interface:ReadStreamResume reading, and sets the buffer inflowingmode. If theReadStreamhas been paused, reading will recommence on it.- Specified by:
resumein interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
fetch
Description copied from interface:ReadStreamFetch the specifiedamountof elements. If theReadStreamhas been paused, reading will recommence with the specifiedamountof items, otherwise the specifiedamountwill be added to the current stream demand.- Specified by:
fetchin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
endHandler
Description copied from interface:ReadStreamSet an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.- Specified by:
endHandlerin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
version
HttpVersion version()- Returns:
- the HTTP version of the request
-
method
HttpMethod method()- Specified by:
methodin interfaceHttpRequestHead- Returns:
- the HTTP method for the request.
-
isSSL
default boolean isSSL()- Returns:
- true if this
NetSocketis encrypted via SSL/TLS
-
scheme
String scheme()- Returns:
- the scheme of the request
-
authority
HostAndPort authority()- Returns:
- the request authority.
- HTTP/2: the :authority pseudo header is returned if present, otherwise the Host header value is returned.
- HTTP/1.x: the Host header is returned
- or
nullwhen no such header is present
HostAndPort.port()returns-1to indicate the scheme port is prevalent.
-
authority
- Parameters:
real- whether to return the value of the real HTTP/2 :authority header, or the computed one.- Returns:
- the authority, either computed or real. May be null when real is
true.
-
bytesRead
long bytesRead()- Returns:
- the total number of bytes read for the body of the request.
-
response
HttpServerResponse response()- Returns:
- the response. Each instance of this class has an
HttpServerResponseinstance attached to it. This is used to send the response back to the client.
-
setParamsCharset
Override the charset to use for decoding the query parameter map, when none is set,UTF8is used.- Parameters:
charset- the charset to use for decoding query params- Returns:
- a reference to this, so the API can be used fluently
-
getParamsCharset
String getParamsCharset()- Returns:
- the charset used for decoding query parameters
-
params
- Returns:
- the query parameters in the request
-
params
- Parameters:
semicolonIsNormalChar- whether semicolon is treated as a normal character or a query parameter separator- Returns:
- the query parameters in the request
-
getParam
-
getParam
Return the first param value with the specified name ordefaultValuewhen the query param is not present- Parameters:
paramName- the param namedefaultValue- the default value, must be non-null- Returns:
- the param value or
defaultValuewhen not present
-
remoteAddress
- Returns:
- the remote address for this connection, possibly
null(e.g a server bound on a domain socket). IfuseProxyProtocolis set totrue, the address returned will be of the actual connecting client.
-
localAddress
- Returns:
- the local address for this connection, possibly
null(e.g a server bound on a domain socket) IfuseProxyProtocolis set totrue, the address returned will be of the proxy.
-
sslSession
- Returns:
- SSLSession associated with the underlying socket. Returns null if connection is not SSL.
- See Also:
-
absoluteURI
String absoluteURI()- Returns:
- the absolute URI corresponding to the HTTP request
-
bodyHandler
Convenience method for receiving the entire request body in one piece.This saves the user having to manually setting a data and end handler and append the chunks of the body until the whole body received. Don't use this if your request body is large - you could potentially run out of RAM.
- Parameters:
bodyHandler- This handler will be called after all the body has been received
-
body
Convenience method for receiving the entire request body in one piece.This saves you having to manually set a dataHandler and an endHandler and append the chunks of the body until the whole body received. Don't use this if your request body is large - you could potentially run out of RAM.
- Returns:
- a future completed with the body result
-
end
-
toNetSocket
Establish a TCP tunnel with the client.This must be called only for
CONNECTHTTP method or for HTTP connection upgrade, before any response is sent.Calling this sends a
200response for aCONNECTor a101for a connection upgrade wit nocontent-lengthheader set and then provides theNetSocketfor handling the created tunnel. Any HTTP header set on the response before calling this method will be sent.server.requestHandler(req -> { if (req.method() == HttpMethod.CONNECT) { // Send a 200 response to accept the connect NetSocket socket = req.netSocket(); socket.handler(buff -> { socket.write(buff); }); } ... });- Returns:
- a future notified with the upgraded socket
-
setExpectMultipart
Call this with true if you are expecting a multi-part body to be submitted in the request. This must be called before the body of the request has been received- Parameters:
expect- true - if you are expecting a multi-part body- Returns:
- a reference to this, so the API can be used fluently
-
isExpectMultipart
boolean isExpectMultipart()- Returns:
- true if we are expecting a multi-part body for this request. See
setExpectMultipart(boolean).
-
uploadHandler
Set an upload handler. The handler will get notified once a new file upload was received to allow you to deal with the file upload.- Returns:
- a reference to this, so the API can be used fluently
-
formAttributes
MultiMap formAttributes()Returns a map of all form attributes in the request.Be aware that the attributes will only be available after the whole body has been received, i.e. after the request end handler has been called.
setExpectMultipart(boolean)must be called first before trying to get the form attributes.- Returns:
- the form attributes
-
getFormAttribute
-
streamId
default long streamId()- Returns:
- the id of the stream of this request, -1 when it is not yet determined, i.e the request has not been yet sent or it is not supported HTTP/1.x
-
canUpgradeToWebSocket
default boolean canUpgradeToWebSocket()- Returns:
- whether this request can be upgraded to a WebSocket, implying it uses HTTP/1.x and presents the correct characteristics for a proper upgrade.
-
toWebSocket
Future<ServerWebSocket> toWebSocket()Upgrade the connection of the current request to a WebSocket.This is an alternative way of handling WebSockets and can only be used if no WebSocket handler is set on the
HttpServer, and can only be used during the upgrade request during the WebSocket handshake.Both
handler(Handler)andendHandler(Handler)will be set to get the full body of the request that is necessary to perform the WebSocket handshake.If you need to do an asynchronous upgrade, i.e not performed immediately in your request handler, you need to
pause()the request in order to not lose HTTP events necessary to upgrade the request.- Returns:
- a future notified with the upgraded WebSocket
-
isEnded
boolean isEnded()Has the request ended? I.e. has the entire request, including the body been read?- Returns:
- true if ended
-
customFrameHandler
Set a custom frame handler. The handler will get notified when the http stream receives an custom HTTP/2 frame. HTTP/2 permits extension of the protocol.- Returns:
- a reference to this, so the API can be used fluently
-
connection
HttpConnection connection()- Returns:
- the
HttpConnectionassociated with this request
-
streamPriority
- Returns:
- the priority of the associated HTTP/2 stream for HTTP/2 otherwise
null
-
streamPriorityHandler
Set an handler for stream priority changesThis is not implemented for HTTP/1.x.
- Parameters:
handler- the handler to be called when stream priority changes
-
decoderResult
DecoderResult decoderResult()- Returns:
- Netty's decoder result useful for handling invalid requests with
HttpServer.invalidRequestHandler(Handler)
-
getCookie
Get the cookie with the specified name. NOTE: this will return just the 1stCookiethat matches the given name, to get all cookies for this name see:cookies(String)- Parameters:
name- the cookie name- Returns:
- the cookie or
nullif not found.
-
getCookie
-
cookieCount
default int cookieCount()- Returns:
- the number of cookies in the cookie jar.
-
cookies
Returns a read only set of parsed cookies that match the given name, or an empty set. Several cookies may share the same name but have different keys. A cookie is unique by its<name, domain, path>tuple. The set entries are references to the request original set. This means that performing property changes in the cookie objects will affect the original object too. NOTE: the returnedSetis read-only. This means any attempt to modify (add or remove to the set), will throwUnsupportedOperationException.- Parameters:
name- the name to be matches- Returns:
- the matching cookies or empty set
-
cookies
Returns a modifiable set of parsed cookies from theCOOKIEheader. Several cookies may share the same name but have different keys. A cookie is unique by its<name, domain, path>tuple. Request cookies are directly linked to response cookies. Any modification to a cookie object in the returned set will mark the cookie to be included in the HTTP response. Removing a cookie from the set, will also mean that it will be removed from the response, regardless if it was modified or not.- Returns:
- a set with all cookies in the cookie jar.
-
routed
Marks this request as being routed to the given route. This is purely informational and is being provided to metrics.- Parameters:
route- The route this request has been routed to.
-